Array.prototype.remove = function () {
    var what, a = arguments, L = a.length, ax;
    while (L && this.length) {
        what = a[--L];
        while ((ax = this.indexOf(what)) !== -1) {
            this.splice(ax, 1);
        }
    }
    return this;
};
var projectsScript = projectsScript || function () {
    var isInit = false;
    var projectListingDataTable = null;
    var selectedProjects = [];

    var init = function () {
        if (isInit) return;
        isInit = true;
        handler();
    };

    var handler = function () {
        projectListDataTable();
        globalScript.initValidator();
        initEditor();

        $("body").on('click', '.select_all', function () { // bulk checked
            var status = this.checked;
            if (status === true) {
                $('#bulk-action-checkbox').prop('checked', true);
                $('body').find(".bulkRow").each(function () {
                    $(this).prop("checked", status);
                    var roleId = $(this).closest('tr').find('.project-id').val();
                    if (selectedProjects.indexOf(roleId) === -1) {
                        selectedProjects.push(roleId);
                    }
                });
            } else {
                $(".bulkRow, .select_all").prop('checked', false);
                $('#bulk-action-checkbox').prop('checked', false);
                selectedProjects = [];
            }
        });

        $('body').on('click', '.bulkRow', function () {
            var status = this.checked;
            var roleId = $(this).closest('tr').find('.project-id').val();
            if (status === true) {
                if (selectedProjects.indexOf(roleId) === -1) {
                    selectedProjects.push(roleId);
                }
                $('#bulk-action-checkbox').prop('checked', true);
            } else {
                selectedProjects.remove(roleId);
            }
            if (selectedProjects.length === 0) {
                $(".bulkRow, .select_all").prop('checked', false);
            }
        });

        $('body').on('click', '#apply_bulk_actions_btn', function () {
            var bulkOption = $('#bulk_actions').val();
            if (bulkOption === '') {
                $('#bulk_actions_error').html('Please select an action first').show();
            } else {
                if (selectedProjects.length === 0) {
                    $('#bulk_actions_error').html('Please select project(s) first').show();
                } else {
                    $('#bulk_actions_error').hide();
                    if (bulkOption === 'delete_bulk') {
                        globalScript.showConfirmationAlert(
                            'You want to delete selected project(s)?',
                            function () {
                                deleteProjects(function () {
                                    toastr.success('Project(s) deleted successfully');
                                    projectListDataTable();
                                    $(".bulkRow, .select_all").prop('checked', false);
                                });
                            }
                        )
                    }
                }
            }
        });

        $('body').on('submit', '#create_project_form', function (e) {
            e.preventDefault();
            if ($('#submit_btn').hasClass('disabled')) {
                return false;
            }
            $('#submit_btn').addClass('disabled');
            $('.add_errors').hide();
            $('.add_errors ul').html('');
            var project_name = $('#project_name').val();
            var project_area = $('#project_area').val();
            var project_meta_title = $('#project_meta_title').val();
            var project_meta_keywords = $('#project_meta_keywords').val();
            var project_meta_description = $('#project_meta_description').val();
            var project_full_description = $('#project_full_description').summernote('code');
            var obj = Object.create(globalScript.CREATE_ATTRIBUTE);
            obj.data = {
                'type': 'project',
                'name': project_name,
                'parent_id': project_area,
                'full_desc': project_full_description,
                'meta_title': project_meta_title,
                'meta_keywords': project_meta_keywords,
                'meta_desc': project_meta_description,
            };
            globalScript.ajaxCall(obj).done(function (response) {
                if (response.errors && response.errors.length !== 0) {
                    $('.add_errors').show();
                    $('#submit_btn').removeClass('disabled');
                    _.each(response.errors, function (v, k) {
                        $('.add_errors ul').append('<li>' + v + '</li>');
                    });
                    return false;
                } else {
                    toastr.success(response._metadata.message);
                    $('#addProjectModal').modal('hide');
                    projectListDataTable();
                }
            });
        });

        $('body').on('submit', '#edit_project_form', function (e) {
            e.preventDefault();
            if ($('#edit_submit_btn').hasClass('disabled')) {
                return false;
            }
            $('#edit_submit_btn').addClass('disabled');
            $('.edit_errors').hide();
            $('.edit_errors ul').html('');
            var projectId = $('#project_id').val();
            var project_name = $('#edit_project_name').val();
            var project_area = $('#edit_project_area').val();
            var project_meta_title = $('#edit_project_meta_title').val();
            var project_meta_keywords = $('#edit_project_meta_keywords').val();
            var project_meta_description = $('#edit_project_meta_description').val();
            var project_full_description = $('#edit_project_full_description').summernote('code');
            var obj = Object.create(globalScript.UPDATE_ATTRIBUTE);
            obj.url = obj.url(projectId);
            obj.data = {
                'name': project_name,
                'parent_id': project_area,
                'full_desc': project_full_description,
                'meta_title': project_meta_title,
                'meta_keywords': project_meta_keywords,
                'meta_desc': project_meta_description,
            };
            globalScript.ajaxCall(obj).done(function (response) {
                if (response.errors && response.errors.length !== 0) {
                    $('#edit_submit_btn').removeClass('disabled');
                    _.each(response.errors, function (v, k) {
                        $('.edit_errors ul').append('<li>' + v + '</li>');
                        $('.edit_errors').show();
                    });
                } else {
                    toastr.success(response._metadata.message);
                    $('#editProjectModal').modal('hide');
                    projectListDataTable();
                }
            });
        });

        $('body').on('click', '.edit-btn', function () {
            var projectId = $(this).closest('tr').find('.project-id').val();
            var obj = Object.create(globalScript.GET_ATTRIBUTE_DETAILS);
            var url = obj.url(projectId);
            obj.url = url;
            globalScript.ajaxCall(obj).done(function (response) {
                if (response.hasOwnProperty('_metadata') && response._metadata.hasOwnProperty('outcomeCode') && response._metadata.outcomeCode === 0) {
                    $('body').find('#project_id').val(response.records.id);
                    $('body').find('#edit_project_form #edit_project_name').val(response.records.name);
                    $('body').find('#edit_project_form #edit_project_area').selectpicker('val', response.records.parent_id);
                    $('body').find('#edit_project_form #edit_project_meta_title').val(response.records.meta_title);
                    $('body').find('#edit_project_form #edit_project_meta_keywords').val(response.records.meta_keywords);
                    $('body').find('#edit_project_form #edit_project_meta_description').val(response.records.meta_desc);
                    $('body').find('#edit_project_form #edit_project_full_description').summernote("code", response.records.full_desc);
                    $('.edit_errors').hide();
                    $('.edit_errors ul').html('');
                    $('#editProjectModal').modal('show');
                }
            })
        });

        $('body').on('click', '.delete-btn', function () {
            selectedProjects = [];
            $(".bulkRow, .select_all").prop('checked', false);
            var projectId = $(this).closest('tr').find('.project-id').val();
            selectedProjects.push(projectId);
            globalScript.showConfirmationAlert(
                'You want to delete?',
                function () {
                    deleteProjects(function () {
                        toastr.success('Deleted successfully');
                        projectListDataTable();
                    });
                }
            )
        });

        $('#addProjectModal').on('hidden.bs.modal', function (e) {
            $('.add_errors').hide();
            $('.add_errors ul').html('');
            $('#project_area').selectpicker('val', '');
            $('#create_project_form').trigger("reset");
            $('#project_full_description').summernote('reset');
        });

        $('#editProjectModal').on('hidden.bs.modal', function (e) {
            $('.edit_errors').hide();
            $('.edit_errors ul').html('');
            $('#edit_project_form').trigger("reset");
            $('#edit_project_full_description').summernote('reset');
        });
    };

    var deleteProjects = function (callback) {
        var obj = Object.create(globalScript.DELETE_ATTRIBUTE);
        obj.data = {
            'attribute_ids[]': selectedProjects
        };
        globalScript.ajaxCall(obj).done(function (response) {
            selectedProjects = [];
            if (typeof callback == 'function') callback();
        });
    };

    var projectListDataTable = function () {
        if (projectListingDataTable != null) {
            projectListingDataTable.clear().destroy();
        }
        projectListingDataTable = $('#projectsListTable').DataTable({
            "ajax": {
                url: globalScript.APP_URL + "attributes?type=project",
                type: "GET",
                xhrFields: {
                    withCredentials: true
                },
                dataSrc: function (json) {
                    if (json.hasOwnProperty('_metadata') && json._metadata.hasOwnProperty('outcomeCode') && json._metadata.outcomeCode === 4) {
                        window.top.location.href = "login";
                        return;
                    }
                    json.draw = json.records.draw;
                    json.recordsTotal = json.records.recordsTotal;
                    json.recordsFiltered = json.records.recordsFiltered;
                    $('body').find('#module_total_count').html(json.records.recordsTotal);
                    if (json.records.data.length !== 0) {
                        $("body").find(".f_custom_checkbox").css('pointer-events', 'all');
                        $("body").find(".f_custom_card_footer").show();
                    } else {
                        $("body").find(".f_custom_card_footer").hide();
                    }
                    return json.records.data;
                }
            },
            "searching": true,
            "ordering": true,
            "serverSide": true,
            "paging": true,
            "stateSave": false,
            "columns": [
                {
                    "orderable": true,
                    "searchable": false,
                    "data": 'created_at',
                    "visible": false
                },
                {
                    "data": "name",
                    "title": "Title",
                    "name": "name",
                    "searchable": true,
                    "orderable": true
                },
                {
                    "data": "parent",
                    "title": "Area",
                    "name": "parent.name",
                    "searchable": false,
                    "orderable": false
                },
                {
                    "data": null,
                    "title": "Actions",
                    "searchable": false,
                    "orderable": false
                }
            ],
            "order": [[0, 'desc']],
            "rowCallback": function (row, data) {
                var tmpl = _.template($('#projectsListTemplate').html());
                $(row).html(tmpl(data));
            }
        });
    };

    var initEditor = function () {
        $('.content_area').summernote({
            onCreateLink: function (originalLink) {
                return originalLink; // return original link
            },
            dialogsInBody: true,
            height: 300,
            tabsize: 2
        });
    };

    return {
        'init': init
    }

}();

$(document).ready(function () {
    projectsScript.init();
});
